/*** HELP.C ***/

#include	"main.h"					/* "TwinTail_de_AngelMode!!" System Header File			*/

#define		red			C_RED(1),  C_DEF(1)
#define		gre			C_GRE(1),  C_DEF(1)
#define		yel			C_YEL(1),  C_DEF(1)
#define		blu			C_BLU(1),  C_DEF(1)
#define		mag			C_MAG(1),  C_DEF(1)
#define		cya			C_CYA(1),  C_DEF(1)
#define		whi			C_WHI(1),  C_DEF(1)
#define		def			C_DEF(1),  C_DEF(1)

#define		r_blu		R_BLU(1),  R_DEF(1)
#define		r_gre		R_GRE(1),  R_DEF(1)
#define		r_red		R_RED(1),  R_DEF(1)
#define		r_def		R_DEF(1),  R_DEF(1)

#define		w_blu(s)	C_BLU(1),s,C_DEF(1)
#define		w_gre(s)	C_GRE(1),s,C_DEF(1)
#define		w_cya(s)	C_CYA(1),s,C_DEF(1)

/************************************************************************************************/
// DISP_USAGE() - Display TT-Engine Usage.
/************************************************************************************************/
void disp_usage(void){
/*--1---2---3---4---5---6---7---8---9---A---B---C---D---E---F---G---H---I---J---K---L---M---N---*/
	printf("\n");
	printf("Usage: %s%s%s [%sOption%s] [%sFileName%s]\n",w_blu(TTdeAM_CMD),cya,mag);
	printf("\n");
	printf("  %s-h | -?%s = Display Usage   Information ( This Page ) & Exit\n"	,cya);
	printf("  %s-v     %s = Display Version Information               & Exit\n"	,cya);
	printf("  %s-i     %s = Execute in Interactive Mode\n"						,cya);
	printf("  %s-e     %s = Execute in OneLiner    Mode\n"						,cya);
	printf("  %s-t | -x%s = Enable Runtime Trace for Debug [ %s-t -tt -ttt ... | -x -xx -xxx ...%s ]\n",cya,cya);
	printf("  %s-c | -m%s = {Color|Mono} Text Mode (Default=Auto)\n"			,cya);
	printf("\n");
	printf("  %s-:%s = Display Manual for :CMD < Runtime Command >\n"			,cya);
	printf("  %s-#%s = Display Manual for System関数＆System変数 #={#|0-9}\n"	,cya);
	printf("\n");
	printf("!!! %sDebug Option%s !!!\n"											,yel);
	printf("  %s\"--\"Dummy \"-C\"kOnly \"-F\"lex \"-B\"ison \"-M\"em \"-G\"c \"-N\"et \"-^\"Sig \"-!\"Ctr%s\n",yel);
	printf("\n");
}

/************************************************************************************************/
// DISP_VERNO() - Display TT-Engine Version.
/************************************************************************************************/
void disp_verno(void){
/*--1---2---3---4---5---6---7---8---9---A---B---C---D---E---F---G---H---I---J---K---L---M---N---*/
	printf("\n");
	printf("TwinTail_de_AngelMode!! Ver.%s%s%s",w_blu(TTdeAM_VER));
	printf(" (Int=%s%zu%s[Bit]/Dbl=%s%zu%s[Bit]/Ptr=%s%zu%s[Bit])\n",
		w_gre(sizeof(tint )*8), w_gre(sizeof(tdbl )*8), w_gre(sizeof(void*)*8));
	printf("Copyright (C) 2011.08.15-2019 \"%sNekoMimi(F)%s\" <twintail@angelmode.net>\n",red);
	printf("\n");
}

/************************************************************************************************/
// DISP_MANUAL() display ":CMD" Help & TT-Lang Manual.
/************************************************************************************************/
void disp_manual(int mode){
/*--1---2---3---4---5---6---7---8---9---A---B---C---D---E---F---G---H---I---J---K---L---M---N---*/
	printf("\n");
	if( mode==':' || mode=='?' ){		// ':' List :CMD    || '?' Hidden Command
		printf("*** Manual for :CMD < Runtime Command > *** [ \'%s:%s\' must be 1st column ]\n"	,red);
		printf("  %s:h | :?     %s -> Display :CMD < Runtime Command > Manual ( This Page )\n"	,red);
		printf("  %s:r[ead] FILE%s -> Read  TT-Script       from FILE.\n"						,red);
		printf("  %s:w[rit] FILE%s -> Write Command History into FILE.\n"						,red);
		printf("  %s:c[ode]     %s -> Set Start of TT-Script *CODE*. { = __code__ }\n"			,red);
		printf("  %s:d[ata]     %s -> Set Start of Embedded  *DATA*. { = __data__ }\n"			,red);
		printf("  %s:q[uit]     %s -> Quit TT-Engine ASAP!!          { =  Ctrl+C  }\n"			,red);
		printf("\n");
		printf("!!! %sDebug Command%s !!!\n"													,yel);
		printf("  %s:cpu  :mem  :ds  :rs  :ft  :dt[ab] #  :ct[re] #  ( # = {Dec|Hex} )%s\n"		,yel);
		printf("%s", mode=='?' ? "\n" : "" );
	}
/*--1---2---3---4---5---6---7---8---9---A---B---C---D---E---F---G---H---I---J---K---L---M---N---*/
	if( mode=='#' || mode=='?' ){		// '#' List {#|0-9} || '?' Hidden Command
		char c = ( mode=='?' ? ':' : '-' );
		printf("*** Manual for System関数＆System変数 #={#|0-9} ***\n"			);
		printf("  %s%c#%s = Display System関数＆System変数 Manual (This Page )\n"				,w_cya(c));
		printf("  %s%c0%s = 基本事項と基本パラメーター\n"										,w_cya(c));
		printf("  %s%c1%s = コマンドライン[CmdLine ]＆環境変数[Environ ]\n"						,w_cya(c));
		printf("  %s%c2%s = ファイル入出力[FileI/O ]\n"											,w_cya(c));
		printf("  %s%c3%s = 書式付き出力  [Print   ]＆簡易表示 変換書式\n"						,w_cya(c));
		printf("  %s%c4%s = 文字列の操作  [String  ]\n"											,w_cya(c));
		printf("  %s%c5%s = データの操作  [Data    ]\n"											,w_cya(c));
		printf("  %s%c6%s = ネットワーク  [Network ]\n"											,w_cya(c));
		printf("  %s%c7%s = 数学関連      [Math    ]\n"											,w_cya(c));
	}
	if( mode=='0' ){					// 'B'asic Parameter
		printf("%s[基 本 事 項]%s\n"            													,r_blu);
		printf("  基本データ型: S=\"文字列\"  I=整数型  D=実数型  P=ポインタ  X=関数型\n"			);
		printf("  派生データ型: 配列型と構造体  A[x]  B[x,y]  C.x D.x.y  配列リテラル  E={x,y,z}\n"	);
		printf("  変数定義とスコープ: {global|static|*local*} V=初期値 (*default* ,型は代入値)\n"	);
		printf("  関数定義とスコープ: def F(x,y){ ... }                (常にglobal,型は戻り値)\n"	);
		printf("%s[System変数]%s NULL / TRUE / FALS / VER  / PID\n"             					,r_gre);
		printf("%s            %s {INT|DBL|PTR}_SIZE / DBL_{MANTSIZE|EXPOSIZE}\n"					,r_def);
		printf("%s[System関数]%s\n"																	,r_red);
		printf("  DATA型の種別: i=type  (*)\n");
		printf("  DATA型の判定: i=isnull(*)     i=istrue(*)     i=isfals(*)     i=isstr (*)     i=isint (*)\n");
		printf("                i=isdbl (*)     i=isptr (*)     i=isfunc(*)     i=isarry(*)\n"                );
		printf("  定義＆未定義: i=isdef (*)     u=erase (*)\n"                                                );
	}
	if( mode=='1' ){					// 'C'mdline
		eprin("%s*** CmdLine & Environ ***%s\n",R_BLU(2),C_DEF(2));
		eprin("%s[System変数]%s argc / argv / argr / args / cmd  / env\n",R_GRE(2),C_DEF(2));
		eprin("%s[System関数]%s\n",R_RED(2),C_DEF(2));
		eprin("  引数の取得  : s=shift([*])    s=opshift([*])\n");
		eprin("  引数の返却  :                 i=unshift(   )\n");
	}
	if( mode=='2' ){					// 'F'ileI/O
		eprin("%s*** FileI/O & Related ***%s\n",R_BLU(2),C_DEF(2));
		eprin("%s[System変数]%s stdin / stdout / stderr / :code / :data\n",R_GRE(2),C_DEF(2));
		eprin("%s[System関数]%s\n",R_RED(2),C_DEF(2));
		eprin("  １文字単位  : i=getc([f])     i=putc([f,]i)   i=ungetc([f,]i)            \n");
		eprin("  １行  単位  : s=gets([f])     i=puts([f,]s)   i=ungets([f,]s)            \n");
		eprin("  １行[max=n] : s=getn([f],n)   i=putn([f,]s,n) i=ungetn([f,]s,n)          \n");
		eprin("  Binary(RAW) : (p,n)=read([f,]n) & n=write([f,]p,n)                       \n");
		eprin("  Fileポインタ: p=open(f,s)     i=close(f)      i=flush(f)                 \n");
		eprin("  File操作位置: i=getpos(f)     i=setpos(f,i)   i=movpos(f,i)   i=rewind(f)\n");
	}
	if( mode=='3' ){					// 'P'rint
		eprin("%s*** Print & Display ***%s\n",R_BLU(2),C_DEF(2));
		eprin("%s[System変数]%s 色 ( ANSI Color ) = {C|B|U|R}_{BLA|RED|GRE|YEL|BLU|MAG|CYA|WHI|DEF}\n",R_GRE(2),C_DEF(2));
		eprin("%s            %s Default 変換書式  = FMT_{S2S|I2S|D2S|P2S|N2S}\n",C_DEF(2),C_DEF(2));
		eprin("%s[System関数]%s\n",R_RED(2),C_DEF(2));
		eprin("  書式付き出力: i= print(s...)  i=fprint(f,s...)  i=eprint(s...)  s=sprint(s...)\n");
		eprin("  出力＆終了  : u= dying(s...)\n");
		eprin("  簡易＆詳細  : u= p    (*...)  u= d    (*...)\n");
	}
	if( mode=='4' ){					// 'S'tring
		eprin("%s*** String & Related ***%s\n",R_BLU(2),C_DEF(2));
		eprin("%s[System関数]%s\n",R_RED(2),C_DEF(2));
//                     +   +   *   +   +   +   *   +   +   +   *   +   +   +   *   +   +   +   *
		eprin("  文字列の比較: i=strcmp[i](s1,s2)  i=strncmp[i](s1,s2)                       \n");
		eprin("  文字列の検索: i=str[r]chr(s,chr)  i=str[r]str (s,str) (Is,Ie)=strreg(s,/RE/)\n");
		eprin("  文字列の置換: s={s|g}sub(s,@1,@2) s={e|r}valesc(s)    {s|i}={uc|lc}({s|i})  \n");
		eprin("  改行の削除  : s=strip (s)         s={h|t}strip (s)                          \n");
		eprin("  部分文字(列): i=subchr(s,i)       s=substr(s,Is,Ie)                         \n");
		eprin("  配列化｜要素: {a|s}=[p]split(s,@[,i])    {a|s}=[p]scan(s,@[,i])\n");
	}
	if( mode=='5' ){					// 'D'ata
		eprin("%s*** Data & Related ***%s\n",R_BLU(2),C_DEF(2));
		eprin("%s[System関数]%s\n",R_RED(2),C_DEF(2));
//                     +   +   *   +   +   +   *   +   +   +   *   +   +   +   *   +   +   +   *
		eprin("  データの変換: i=int(*)    d=dbl(*)    {i|d}=atov(*)   s=str(*)    p=ptr(*)  \n");
		eprin("              : i={bin|oct|dec|hex}(s)  /RE/=reg(s)                           \n");
		eprin("  データの判定: i=is{alnum|alpha|ascii|blank|cntrl|digit|graph|lower|print|punct|space|upper|xdigit}(i)\n");
		eprin("  消去と複製  : u=erase(*)      *=dup(*)\n");
		eprin("  サイズ計測  : i=size (*)      i=strlen(s)\n");
		eprin("  配列の処理  : a=vals (a)      a=keys(a)       i=ndim(a)       a=shape(a)    \n");
	}



	if( mode=='6' ){					// 'N'etwork
		eprin("%s*** Network ***%s\n",R_BLU(2),C_DEF(2));
		eprin("%s[System変数]%s {UDP|TCP|RAW}_SOCKET / {UDP|TCP|RAW}_TIMEOUT [Sec]\n",R_GRE(2),C_DEF(2));
		eprin("%s[System関数]%s\n",R_RED(2),C_DEF(2));
//                     +   +   *   +   +   +   *   +   +   +   *   +   +   +   *   +   +   +   *
		eprin("UDPソケット作成: sock = udp_socket([ip,port])   ### Client=不要,Server=必要 ###\n");
		eprin("  UDPデータ送信:     len               = tx_udp([sock,]ip,port,buf[,len])      \n");
		eprin("  UDPデータ受信:     (ip,port,buf,len) = rx_udp([sock])                        \n");
		eprin("TCPソケット作成: sock = tcp_socket([ip,port])   ### Client=不要,Server=必要 ###\n");
		eprin("  *Server側準備: sock = listen ([sock]        )                                \n");
		eprin("  *Client側準備: sock = connect([sock,]ip,port)                                \n");
		eprin("  TCPデータ送信:     len               = tx_tcp([sock,]        buf[,len])      \n");
		eprin("  TCPデータ受信:     (buf,len)         = rx_tcp([sock])                        \n");
		eprin("RAWソケット作成: sock = raw_socket([ip])                                       \n");
		eprin("  Ping送信&受信:     sec = ping(ip)                                            \n");
		eprin("共通 Socket情報: (l_ip,s,l_port,s,l_type,r_ip,s,r_port,s,r_type)=sockinfo(sock)\n");
		eprin("共通 IpAddr変換: s =   ip2str({i|s})        i =   ip2int({i|s})                \n");
		eprin("共通 PortNo変換: s = port2str(Proto,{i|s})  i = port2int(Proto,{i|s})          \n");
	}
	if( mode=='7' ){					// 'M'ath
		eprin("%s*** Math & Calc ***%s\n",R_BLU(2),C_DEF(2));
		eprin("%s[System変数]%s INF / NAN / M_E / M_PI / {INT|DBL}_{MAX|MIN|QUANT|EPSILON}\n",R_GRE(2),C_DEF(2));
		eprin("%s            %s デフォルト角度単位 SYS_ANGLE = *RAD* or DEG ( *default* ) \n",C_DEF(2),C_DEF(2));
		eprin("%s[System関数]%s\n",R_RED(2),C_DEF(2));
		eprin("  実数丸め込み: y=ceil (x)    y=floor(x)    y=trunc(x)    y=rint (x)    y=round(x)   \n");
		eprin("  絶 対 値    : y=abs  (x)                                                           \n");
		eprin("  実数分解合成: (y,z)=modf(x)               (y,i)=frexp(x) & x=ldexp(y,i)            \n");
		eprin("  指数関数    : y=exp  (x)    y=exp2 (x)    y=exp10(x)    y=lin  (x)                 \n");
		eprin("  対数関数    : y=log  (x)    y=log2 (x)    y=log10(x)    y=dbi  (x)                 \n");
		eprin("  乗余＆ルート: z=pow(x,y)    z=mod(x,y)    y=sqrt (x)    y=cbrt (x)                 \n");
		eprin("  角度変換    : y=deg(x)  y=rad(x)  (x,y,z)={rad|deg}2dms(a)  a=dms2{rad|deg}(x,y,z) \n");
		eprin("  三角関数    : y=[a]sin (x)  y=[a]cos (x)  y=[a]tan (x)  z=atan2(x,y)               \n");
		eprin("  双曲関数    : y=[a]sinh(x)  y=[a]cosh(x)  y=[a]tanh(x)                             \n");
		eprin("  ベッセル関数: y={j0|y0}(x)  y={j1|y1}(x)  y={jn|yn}(x,y)                           \n");
		eprin("  座標変換    : (x,y,z)={x|y|z}rot(x,y,z,a)                                          \n");
		eprin("  最大最小中央: y={max|min|med}(@)  i=arg{max|min}(@)  (i,j)=argmed(@)               \n");
		eprin("  合計＆平均  : y=sum  (@)    y=ave  (@)                                             \n");
		eprin("  分散＆偏差  : y=svar (@)    y=uvar (@)    y=sdev (@)    y=udev (@)                 \n");
		eprin("  ガンマ＆誤差: y=lgamma(x)   y=tgamma(x)   y=erf  (x)    y=erfc (x)                 \n");
		eprin("  乱数発生    : u=seed (i)    i=rand (i)    y=urand(x)    z=nrand(x,y)               \n");
		eprin("  数値判定    : i=isinf(x)    i=isnan(x)                                             \n");
	}
	printf("\n");
}
